<?php
/*
* @version      1.5.5
* @author       RADAR
* @package      Jshopping
*/
defined('_JEXEC') or die('Restricted access');
require_once(__DIR__ . '/include.php');
if (!class_exists('DiscountHelper')) {
require_once(__DIR__ . '/DiscountHelper.php');
}

class pm_radar_dsk_bank extends PaymentRoot
{
const VERSION = '1.5.5';
const ORDER_APPROVED = 'approved';
const ORDER_DECLINED = 'declined';
const SIGNATURE_SEPARATOR = '|';
const ORDER_SEPARATOR = ":";
public $allowCallbacks = RADAR_DSK_BANK_ENABLE_CALLBACK; //temporarily disabled globally
public $cacert_path = null;
function showPaymentForm($params, $pmconfigs)
{
include(dirname(__FILE__) . "/paymentform.php");
}
function showAdminFormParams($params)
{
$module_params_array = array(
'radar_dsk_bank_merchant_login',
'radar_dsk_bank_merchant_password',
'radar_dsk_bank_test_mode',
'radar_dsk_bank_two_stage',
'radar_dsk_bank_send_order',
'radar_dsk_bank_tax_system',
'transaction_end_status',
'transaction_failed_status',
);
foreach ($module_params_array as $module_param) {
if (!isset($params[$module_param]))
$params[$module_param] = '';
}
$this->_loadLanguageFile();
$radar_dsk_bank_taxSystems = array();
$radar_dsk_bank_taxSystems[] = JHTML::_('select.option', 0, _JSHOP_RADAR_ENTRY_TAX_SYSTEM_1, 'id', 'name');
$radar_dsk_bank_taxSystems[] = JHTML::_('select.option', 1, _JSHOP_RADAR_ENTRY_TAX_SYSTEM_2, 'id', 'name');
$radar_dsk_bank_taxSystems[] = JHTML::_('select.option', 2, _JSHOP_RADAR_ENTRY_TAX_SYSTEM_3, 'id', 'name');
$radar_dsk_bank_taxSystems[] = JHTML::_('select.option', 3, _JSHOP_RADAR_ENTRY_TAX_SYSTEM_4, 'id', 'name');
$radar_dsk_bank_taxSystems[] = JHTML::_('select.option', 4, _JSHOP_RADAR_ENTRY_TAX_SYSTEM_5, 'id', 'name');
$radar_dsk_bank_taxSystems[] = JHTML::_('select.option', 5, _JSHOP_RADAR_ENTRY_TAX_SYSTEM_6, 'id', 'name');
$radar_dsk_bank_ffdVersions = array();
$radar_dsk_bank_ffdVersions[] = JHTML::_('select.option', 'v1_05', 'v1.05', 'id', 'name');
$radar_dsk_bank_ffdVersions[] = JHTML::_('select.option', 'v1_2', 'v1.2', 'id', 'name');
$radar_dsk_bank_ffd_paymentMethodTypeList = array();
$radar_dsk_bank_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '1', _JSHOP_RADAR_ENTRY_PAYMENT_METHOD_1, 'id', 'name');
$radar_dsk_bank_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '2', _JSHOP_RADAR_ENTRY_PAYMENT_METHOD_2, 'id', 'name');
$radar_dsk_bank_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '3', _JSHOP_RADAR_ENTRY_PAYMENT_METHOD_3, 'id', 'name');
$radar_dsk_bank_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '4', _JSHOP_RADAR_ENTRY_PAYMENT_METHOD_4, 'id', 'name');
$radar_dsk_bank_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '5', _JSHOP_RADAR_ENTRY_PAYMENT_METHOD_5, 'id', 'name');
$radar_dsk_bank_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '6', _JSHOP_RADAR_ENTRY_PAYMENT_METHOD_6, 'id', 'name');
$radar_dsk_bank_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '7', _JSHOP_RADAR_ENTRY_PAYMENT_METHOD_7, 'id', 'name');
$radar_dsk_bank_ffd_paymentObjectTypeList = array();
$radar_dsk_bank_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '1', _JSHOP_RADAR_ENTRY_PAYMENT_OBJECT_1, 'id', 'name');
$radar_dsk_bank_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '2', _JSHOP_RADAR_ENTRY_PAYMENT_OBJECT_2, 'id', 'name');
$radar_dsk_bank_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '3', _JSHOP_RADAR_ENTRY_PAYMENT_OBJECT_3, 'id', 'name');
$radar_dsk_bank_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '4', _JSHOP_RADAR_ENTRY_PAYMENT_OBJECT_4, 'id', 'name');
$radar_dsk_bank_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '5', _JSHOP_RADAR_ENTRY_PAYMENT_OBJECT_5, 'id', 'name');
$radar_dsk_bank_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '7', _JSHOP_RADAR_ENTRY_PAYMENT_OBJECT_7, 'id', 'name');
$radar_dsk_bank_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '9', _JSHOP_RADAR_ENTRY_PAYMENT_OBJECT_9, 'id', 'name');
$radar_dsk_bank_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '10', _JSHOP_RADAR_ENTRY_PAYMENT_OBJECT_10, 'id', 'name');
$radar_dsk_bank_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '12', _JSHOP_RADAR_ENTRY_PAYMENT_OBJECT_12, 'id', 'name');
$radar_dsk_bank_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '13', _JSHOP_RADAR_ENTRY_PAYMENT_OBJECT_13, 'id', 'name');

$orders = JModelLegacy::getInstance('orders', 'JshoppingModel');
include dirname(__FILE__) . '/adminparamsform.php';
}
function showEndForm($pmconfigs, $order)
{
$lang = \JFactory::getLanguage()->getTag();
$language = substr($lang, 0, 2);
$order_id = $order->order_id;
$description = 'Order :' . $order_id;
$base_url = JURI::root() . 'index.php?option=com_jshopping&controller=checkout&task=step7&js_paymentclass=' . __CLASS__ . '&order_id=' . $order_id;
$return_url = $base_url . '&radar_dsk_bank=result&act=finish';
$callback_url = $base_url . '&radar_dsk_bank=callback&act=finish';
$fail_url = $base_url . '&act=cancel';
$amount = round($this->_fixOrderTotal($order) * 100);
$jsonParams_array = array(
'CMS:' => 'Joomla + Jshopping ',
'Module-Version: ' => self::VERSION,
);
if (defined('RADAR_DSK_BANK_ENABLE_BACK_URL_SETTINGS')
&& RADAR_DSK_BANK_ENABLE_BACK_URL_SETTINGS === true
&& !empty($pmconfigs['radar_dsk_bank_back_url'])
) {
$jsonParams_array['backToShopUrl'] = $pmconfigs['radar_dsk_bank_back_url'];
}
$radar_dsk_bank_args = array(
'orderNumber' => $order_id . self::ORDER_SEPARATOR . time(),
'userName' => $pmconfigs['radar_dsk_bank_merchant_login'],
'password' => $pmconfigs['radar_dsk_bank_merchant_password'],
'amount' => $amount,
'returnUrl' => $return_url,
'dynamicCallbackUrl' => $callback_url . "&CALLBACK_TYPE=DYNAMIC",
'failUrl' => $fail_url,
'language' => $language,
'jsonParams' => json_encode($jsonParams_array),
);
if (!empty($order->user_id && $order->user_id > 0)) {
$client_email = !empty($order->email) ? $order->email : "";
$args['clientId'] = md5($order->user_id . $client_email . JURI::root());
}
if ($pmconfigs['radar_dsk_bank_test_mode'] == 1) {
$action_adr = RADAR_DSK_BANK_TEST_URL;
} else {
$action_adr = RADAR_DSK_BANK_PROD_URL;
if (defined('RADAR_DSK_BANK_PROD_URL_ALTERNATIVE_DOMAIN') && defined('RADAR_DSK_BANK_PROD_URL_ALT_PREFIX')) {
if (substr($pmconfigs['radar_dsk_bank_merchant_login'], 0, strlen(RADAR_DSK_BANK_PROD_URL_ALT_PREFIX)) == RADAR_DSK_BANK_PROD_URL_ALT_PREFIX) {
$pattern = '/^https:\/\/[^\/]+/';
$action_adr = preg_replace($pattern, rtrim(RADAR_DSK_BANK_PROD_URL_ALTERNATIVE_DOMAIN, '/'), $action_adr);
} else {
$this->allowCallbacks = false;
}
}
}
if ($this->allowCallbacks === true) {
$login = $pmconfigs['radar_dsk_bank_merchant_login'];
$password = $pmconfigs['radar_dsk_bank_merchant_password'];
if ($pmconfigs['radar_dsk_bank_test_mode'] == 1) {
$gate_url = str_replace("payment/rest", "mportal/mvc/public/merchant/update", $action_adr);
if (defined('RADAR_DSK_BANK_TEST_URL_ALTERNATIVE_DOMAIN')) {
$pattern = '/^https:\/\/[^\/]+/';
$gate_url = preg_replace($pattern, rtrim(RADAR_DSK_BANK_TEST_URL_ALTERNATIVE_DOMAIN, '/'), $gate_url);
}
} else {
$gate_url = str_replace("payment/rest", "mportal/mvc/public/merchant/update", $action_adr);
if (defined('RADAR_DSK_BANK_PROD_URL_ALTERNATIVE_DOMAIN')) {
$pattern = '/^https:\/\/[^\/]+/';
$gate_url = preg_replace($pattern, rtrim(RADAR_DSK_BANK_PROD_URL_ALTERNATIVE_DOMAIN, '/'), $gate_url);
}
}
$gate_url .= substr($pmconfigs['radar_dsk_bank_merchant_login'], 0, -4); // we guess username = login w/o "-api"
$headers = array(
'Content-Type:application/json',
'Authorization: Basic ' . base64_encode($login . ":" . $password)
);
$data['callbacks_enabled'] = true;
$data['callback_type'] = "DYNAMIC";
$data['callback_http_method'] = "GET";
$data['callback_operations'] = "deposited,approved,declinedByTimeout";
$response = $this->_sendGatewayData(json_encode($data), $gate_url, $headers, $this->cacert_path);
$this->_writeLog($response);
}
if ($pmconfigs['radar_dsk_bank_two_stage'] == 0) {
$action_adr .= 'register.do';
} else {
$action_adr .= 'registerPreAuth.do';
}
if ($pmconfigs['radar_dsk_bank_send_order'] == 1) {
$radar_dsk_bank_args['taxSystem'] = $pmconfigs['radar_dsk_bank_tax_system'];
$order_items = $order->getAllItems();
$itemsCnt = 1;
$orderBundle = [];
$orderBundle['customerDetails'] = array(
'email' => $order->email
);
foreach ($order_items as $value) {
$item = array();
$item_tax = $value->product_tax;
$tax_type = $this->_getTaxType($item_tax);
$product_price = ceil($value->product_item_price * 100);
$item['positionId'] = $itemsCnt++;
$item['name'] = $value->product_name;
if ($pmconfigs['radar_dsk_bank_ffd_version'] == "v1_05") {
$item['quantity'] = array(
'value' => $value->product_quantity,
'measure' => RADAR_DSK_BANK_MEASUREMENT_NAME
);
}
if ($pmconfigs['radar_dsk_bank_ffd_version'] == "v1_2") {
$item['quantity'] = array(
'value' => $value->product_quantity,
'measure' => RADAR_DSK_BANK_MEASUREMENT_CODE
);
}
$item['itemAmount'] = $product_price * $value->product_quantity;
$item['itemCode'] = $value->product_id;
$item['tax'] = array(
'taxType' => $tax_type
);
$item['itemPrice'] = $product_price;
$attributes = array();
$attributes[] = array(
"name" => "paymentMethod",
"value" => $pmconfigs['radar_dsk_bank_ffd_paymentMethodType']
);
$attributes[] = array(
"name" => "paymentObject",
"value" => $pmconfigs['radar_dsk_bank_ffd_paymentObjectType']
);
$item['itemAttributes']['attributes'] = $attributes;
$orderBundle['cartItems']['items'][] = $item;
}
if ($order->order_shipping > 0) {
$amount -= ceil($order->order_shipping * 100);
}
$discountHelper = new DiscountHelper();
$discount = $discountHelper->discoverDiscount($amount, $orderBundle['cartItems']['items']);
if ($discount > 0) {
$discountHelper->setOrderDiscount($discount);
$recalculatedPositions = $discountHelper->normalizeItems($orderBundle['cartItems']['items']);
$orderBundle['cartItems']['items'] = $recalculatedPositions;
}
if ($order->order_shipping > 0) {
$itemShipment['positionId'] = $itemsCnt;
$itemShipment['name'] = _JSHOP_RADAR_PAYMENT_DELIVERY;
if ($pmconfigs['radar_dsk_bank_ffd_version'] == "v1_05") {
$itemShipment['quantity'] = array(
'value' => 1,
'measure' => RADAR_DSK_BANK_MEASUREMENT_NAME
);
}
if ($pmconfigs['radar_dsk_bank_ffd_version'] == "v1_2") {
$itemShipment['quantity'] = array(
'value' => 1,
'measure' => RADAR_DSK_BANK_MEASUREMENT_CODE
);
}
$itemShipment['itemAmount'] = $itemShipment['itemPrice'] = ceil($order->order_shipping * 100);
$itemShipment['itemCode'] = 'Delivery';
$attributes = array();
$attributes[] = array(
"name" => "paymentMethod",
"value" => $pmconfigs['radar_dsk_bank_ffd_paymentMethodType']
);
$attributes[] = array(
"name" => "paymentObject",
"value" => 4
);
$itemShipment['itemAttributes']['attributes'] = $attributes;
$orderBundle['cartItems']['items'][] = $itemShipment;
}
$radar_dsk_bank_args['orderBundle'] = json_encode($orderBundle);
}

if (file_exists(dirname(__FILE__) . "/cacert.cer") && $pmconfigs['radar_dsk_bank_enable_cacert'] == 1) {
$this->cacert_path = dirname(__FILE__) . "/cacert.cer";
}
$response = $this->_sendGatewayData(http_build_query($radar_dsk_bank_args, '', '&'), $action_adr, array(), $this->cacert_path);
$this->_writeLog("[REQUEST]: " . $action_adr . ": \nDATA: " . print_r($radar_dsk_bank_args, true) . "\n[RESPONSE]: " . $response);
$response = json_decode($response, true);
if (!empty($response['formUrl'])) {
header("Location: " . $response['formUrl']);
exit;
} else {
$message = "ERROR #" . $response['errorCode'] . ": " . $response['errorMessage'];
\JFactory::getApplication()->enqueueMessage($message, 'error');
return array(0, $message);
}
}
function checkTransaction($pm_config, $order, $rescode)
{
$this->_loadLanguageFile();
$payment_data = \JFactory::getApplication()->input->get->getArray();
if ($pm_config['radar_dsk_bank_test_mode'] == 1) {
$action_adr = RADAR_DSK_BANK_TEST_URL;
} else {
$action_adr = RADAR_DSK_BANK_PROD_URL;
if (defined('RADAR_DSK_BANK_PROD_URL_ALTERNATIVE_DOMAIN') && defined('RADAR_DSK_BANK_PROD_URL_ALT_PREFIX')) {
if (substr($pm_config['radar_dsk_bank_merchant_login'], 0, strlen(RADAR_DSK_BANK_PROD_URL_ALT_PREFIX)) == RADAR_DSK_BANK_PROD_URL_ALT_PREFIX) {
$pattern = '/^https:\/\/[^\/]+/';
$action_adr = preg_replace($pattern, rtrim(RADAR_DSK_BANK_PROD_URL_ALTERNATIVE_DOMAIN, '/'), $action_adr);
}
}
}
$action_adr .= 'getOrderStatusExtended.do';
$radar_dsk_bank_args = array(
'userName' => $pm_config['radar_dsk_bank_merchant_login'],
'password' => $pm_config['radar_dsk_bank_merchant_password'],
);
if (isset($payment_data['radar_dsk_bank'])) {
$action = $payment_data['radar_dsk_bank'];
switch ($action) {
case "result":
$radar_dsk_bank_args['orderId'] = isset($payment_data['orderId']) ? $payment_data['orderId'] : null;
$response = $this->_sendGatewayData(http_build_query($radar_dsk_bank_args, '', '&'), $action_adr);
$this->_writeLog("[REQUEST RU]: " . $action_adr . ": \nDATA: " . print_r($radar_dsk_bank_args, true) . "\n[RESPONSE]: " . $response);
$response = json_decode($response, true);
$orderStatus = $response['orderStatus'];
if ($orderStatus == '1' || $orderStatus == '2') {
$message = _JSHOP_RADAR_ENTRY_ORDER . " " . $payment_data['order_id'] . " " . _JSHOP_RADAR_ENTRY_WAS_PAID;
\JFactory::getApplication()->enqueueMessage($message . " " . $_REQUEST['payment_id']);
return array(1, _JSHOP_RADAR_ENTRY_WAS_PAID . ' ID:' . $_REQUEST['payment_id']);
} else {
$message = _JSHOP_RADAR_ENTRY_PAYMENT_ERROR;
if ($this->allowCallbacks === false) {
\JFactory::getApplication()->enqueueMessage($message . " " . $_REQUEST['payment_id']);
return array(0, $message);
}
}
break;
case "callback":
$radar_dsk_bank_args['orderId'] = isset($payment_data['mdOrder']) ? $payment_data['mdOrder'] : null;
$response = $this->_sendGatewayData(http_build_query($radar_dsk_bank_args, '', '&'), $action_adr);
$this->_writeLog("[REQUEST CB]: " . $action_adr . ": \nDATA: " . print_r($radar_dsk_bank_args, true) . "\n[RESPONSE]: " . $response);
$response = json_decode($response, true);
$orderStatus = $response['orderStatus'];
if ($orderStatus == '1' || $orderStatus == '2') {
$message = _JSHOP_RADAR_ENTRY_ORDER . " " . $payment_data['order_id'] . " " . _JSHOP_RADAR_ENTRY_WAS_PAID;
\JFactory::getApplication()->enqueueMessage($message . " " . $_REQUEST['payment_id']);
return array(1, _JSHOP_RADAR_ENTRY_WAS_PAID . ' ID:' . $_REQUEST['payment_id']);
} else {
return array(0, _JSHOP_RADAR_ENTRY_PAYMENT_ERROR);
}
break;
}
}
}
function getUrlParams($radar_dsk_bank_config)
{
$params = array();
$params['order_id'] = \JFactory::getApplication()->input->getInt("order_id");
$params['hash'] = "";
$params['checkHash'] = 0;
$params['checkReturnParams'] = 1;
return $params;
}
public function _sendGatewayData($data, $action_address, $headers = array(), $ca_info = null)
{
$curl_opt = array(
CURLOPT_HTTPHEADER => $headers,
CURLOPT_VERBOSE => true,
CURLOPT_SSL_VERIFYHOST => false,
CURLOPT_URL => $action_address,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_POST => true,
CURLOPT_POSTFIELDS => $data,
CURLOPT_HEADER => true,
);
$ssl_verify_peer = false;
if ($ca_info != null) {
$ssl_verify_peer = true;
$curl_opt[CURLOPT_CAINFO] = $ca_info;
}
$curl_opt[CURLOPT_SSL_VERIFYPEER] = $ssl_verify_peer;
$ch = curl_init();
curl_setopt_array($ch, $curl_opt);
$response = curl_exec($ch);
if ($response === false) {
$response['errorCode'] = 999;
$response['errorMessage'] = curl_error($ch);
return json_encode($response);
}
$header_size = curl_getinfo($ch, CURLINFO_HEADER_SIZE);
curl_close($ch);
return substr($response, $header_size);
}
function _writeLog($var, $info = true)
{
$information = "";
if ($var) {
if ($info) {
$information = "\n\n";
$information .= str_repeat("-=", 64);
$information .= "\nDate: " . date('Y-m-d H:i:s') . "\n";
}
$result = $var;
if (is_array($var) || is_object($var)) {
$result = "\n" . print_r($var, true);
}
$result .= "\n\n";
$path = dirname(__FILE__) . '/js_radar_dsk_bank_' . date('Y-m') . '.log';
error_log($information . $result, 3, $path);
return true;
}
return false;
}
function _fixOrderTotal($order)
{
$total = $order->order_total;
if ($order->currency_code_iso == 'HUF') {
$total = round($total);
} else {
$total = number_format($total, 2, '.', '');
}
return $total;
}
function _getTaxType($item_tax)
{
if ($item_tax == 20) {
$tax_type = 6;
} else if ($item_tax == 18) {
$tax_type = 3;
} else if ($item_tax == 10) {
$tax_type = 2;
} else if ($item_tax == 0) {
$tax_type = 1;
} else {
$tax_type = 0;
}
return $tax_type;
}
function _loadLanguageFile()
{
$lang = \JFactory::getLanguage();
$langtag = $lang->getTag();
if (file_exists(JPATH_ROOT . '/components/com_jshopping/payments/' . __CLASS__ . '/lang/' . $langtag . '.php')) {
require_once(JPATH_ROOT . '/components/com_jshopping/payments/' . __CLASS__ . '/lang/' . $langtag . '.php');
} else {
require_once(JPATH_ROOT . '/components/com_jshopping/payments/' . __CLASS__ . '/lang/en-GB.php');
}
}
}