<?php
defined('_JEXEC') or die();
require_once(__DIR__ . '/include.php');
?>
<div class="col100">
<h2><?php echo _JSHOP_RADAR_SETTINGS_HEADER1; ?></h2>
<fieldset class="adminform">
<table class="admintable" width="100%">
<tr>
<td class="key" width="300">
<?php echo _JSHOP_RADAR_LOGIN_LABEL; ?>
</td>
<td>
<input type="text" name="pm_params[radar_dsk_bank_merchant_login]" class="inputbox form-control"
value="<?= isset($params['radar_dsk_bank_merchant_login']) ? $params['radar_dsk_bank_merchant_login'] : "" ?>">
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_RADAR_PASSWORD_LABEL; ?>
</td>
<td>
<input type="text" name="pm_params[radar_dsk_bank_merchant_password]" class="inputbox form-control"
value="<?= isset($params['radar_dsk_bank_merchant_password']) ? $params['radar_dsk_bank_merchant_password'] : "" ?>">
</td>
</tr>
<tr>
<td style="width:400px;" class="key">
<?php echo _JSHOP_RADAR_TEST_MODE_LABEL; ?>
</td>
<td>
<?php
print JHTML::_('select.booleanlist', 'pm_params[radar_dsk_bank_test_mode]', 'class = "inputbox" size = "1"', $params['radar_dsk_bank_test_mode']);
?>
</td>
</tr>
<tr>
<td style="width:250px;" class="key">
<?php echo _JSHOP_RADAR_PHASE_LABEL; ?>
</td>
<td>
<?php
print JHTML::_('select.booleanlist', 'pm_params[radar_dsk_bank_two_stage]', 'class = "inputbox" size = "1"', $params['radar_dsk_bank_two_stage']);
?>
</td>
</tr>
<?php if (file_exists(dirname(__FILE__) . "/cacert.cer")) {?>
<tr>
<td style="width:400px;" class="key">
<?php echo _JSHOP_RADAR_VERIFY_SSL_CERTIFICATE_LABEL; ?>
</td>
<td>
<?php
print JHTML::_('select.booleanlist', 'pm_params[radar_dsk_bank_enable_cacert]', 'class = "inputbox" size = "1"', $params['radar_dsk_bank_enable_cacert']);
?>
</td>
</tr>
<?php }?>
<tr>
<td colspan="2">
<h2><?php echo _JSHOP_RADAR_SETTINGS_HEADER2; ?></h2>
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_RADAR_PAYMENT_STATE_SUCCESSFUL; ?>
</td>
<td>
<?php print JHTML::_('select.genericlist', $orders->getAllOrderStatus(), 'pm_params[transaction_end_status]', 'class = "inputbox form-control form-select" ', 'status_id', 'name', $params['transaction_end_status']); ?>
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_RADAR_PAYMENT_STATE_FAILED; ?>
</td>
<td>
<?php echo JHTML::_('select.genericlist', $orders->getAllOrderStatus(), 'pm_params[transaction_failed_status]', 'class = "inputbox form-control form-select" ', 'status_id', 'name', $params['transaction_failed_status']); ?>
</td>
</tr>
<?php if (defined('RADAR_DSK_BANK_ENABLE_BACK_URL_SETTINGS') && RADAR_DSK_BANK_ENABLE_BACK_URL_SETTINGS === true) : ?>
<tr>
<td class="key" width="300">
<?php echo _JSHOP_RADAR_BACK_URL_LABEL; ?>
</td>
<td>
<input type="text" name="pm_params[radar_dsk_bank_back_url]" class="inputbox form-control"
value="<?= isset($params['radar_dsk_bank_back_url']) ? $params['radar_dsk_bank_back_url'] : "" ?>">
</td>
</tr>
<?php endif; ?>
<?php if (defined('RADAR_DSK_BANK_ENABLE_CART_OPTIONS') && RADAR_DSK_BANK_ENABLE_CART_OPTIONS === true) : ?>
<tr>
<td class="key">
<?php echo _JSHOP_RADAR_SEND_ORDER_LABEL; ?>
</td>
<td>
<?php
print JHTML::_('select.booleanlist', 'pm_params[radar_dsk_bank_send_order]', 'class = "inputbox" size = "1"', $params['radar_dsk_bank_send_order']);
?>
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_RADAR_TAX_SYSTEM_LABEL; ?>
</td>
<td>
<?php echo JHTML::_('select.genericlist', $radar_dsk_bank_taxSystems, 'pm_params[radar_dsk_bank_tax_system]', 'class = "inputbox form-control form-select"', 'id', 'name', $params['radar_dsk_bank_tax_system']); ?>
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_RADAR_FFD_VERSION_LABEL; ?>
</td>
<td>
<?php echo JHTML::_('select.genericlist', $radar_dsk_bank_ffdVersions, 'pm_params[radar_dsk_bank_ffd_version]', 'class = "inputbox form-control form-select"', 'id', 'name', $params['radar_dsk_bank_ffd_version']); ?>
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_RADAR_PAYMENT_METHOD_LABEL; ?>
</td>
<td>
<?php echo JHTML::_('select.genericlist', $radar_dsk_bank_ffd_paymentMethodTypeList, 'pm_params[radar_dsk_bank_ffd_paymentMethodType]', 'class = "inputbox form-control form-select"', 'id', 'name', $params['radar_dsk_bank_ffd_paymentMethodType']); ?>
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_RADAR_PAYMENT_OBJECT_LABEL; ?>
</td>
<td>
<?php echo JHTML::_('select.genericlist', $radar_dsk_bank_ffd_paymentObjectTypeList, 'pm_params[radar_dsk_bank_ffd_paymentObjectType]', 'class = "inputbox form-control form-select"', 'id', 'name', $params['radar_dsk_bank_ffd_paymentObjectType']); ?>
</td>
</tr>
<?php endif; ?>
</table>
</fieldset>
</div>
<div class="clr"></div>